<template>
    <div :class="$style.container">
        <o-table
            v-for="tableIndex in tableColumnsNumber"
            :key="tableIndex"
            :data="getDataForTable(tableIndex - 1)"
            :bordered="true"
            striped
            :mobile-cards="false"
        >
            <o-table-column
                v-for="(column, idx) in columns"
                :key="idx"
                v-slot="{ row }"
                v-bind="column"
                :class="{
                    [$style.odd]: idx,
                }"
                :td-attrs="setTdAttrs"
            >
                {{ row[column.field] }}
            </o-table-column>
        </o-table>
    </div>
</template>

<script>
export default {
    name: 'TablesSection',

    props: {
        items: {
            type: Array,
            default: () => [],
        },
        columns: {
            type: Array,
            default: () => [],
        },
        tablesNumber: {
            type: Number,
            default: 4,
        },
        defaultWidth: {
            type: Number,
            default: 170,
        },
    },

    computed: {
        tableColumnsNumber() {
            return this.tablesNumber
        },
        rowsNumber() {
            return Math.ceil(this.items.length / this.tableColumnsNumber)
        },
    },

    methods: {
        getDataForTable(tableIndex) {
            const startIndex = tableIndex * this.rowsNumber
            return this.items.slice(startIndex, startIndex + this.rowsNumber)
        },
        setTdAttrs(rowData, rowIndex) {
            console.log('rowIndex')
            console.log(rowIndex)
            return {
                class: rowIndex % 2 === 0 ? 'even' : this.$style.odd,
            }
        },
    },
}
</script>

<style lang="scss" module>
@import '@/assets/styles';

.container {
    display: flex;
    gap: 32px;

    table {
        border-collapse: collapse;
        border: 1px solid black;
        margin-right: 32px !important;
        // width: 170px !important;
    }

    th {
        @extend %text1;
        height: 56px !important;
        padding-top: 20px !important;
        padding-bottom: 0px !important;
        padding: 36px 0px 20px 12px;
    }

    td {
        @extend %text2;
        vertical-align: middle !important;
        height: 48px !important;
        padding: 8px 12px 8px 12px;
        &:first-child {
            background-color: red !important;
            text-align: right !important;
        }
    }
    :global(.o-table__td:nth-of-type(2n)) {
        background-color: red !important;
        text-align: right !important;
    }

    tr:nth-of-type(2n + 2) {
        background-color: #f8f7fb;
    }
}
.odd {
    td {
        text-align: center;
        background-color: red !important;
    }
}
</style>
